\section{Production Systems}
The system keeps an ongoing memory of assertions the working memory (\textbf{WM}).
The assertions can be changed by \textbf{production rules}.
The Syntax of such rules is given by \texttt{IF \textit{conditions} THEN \textit{actions}}.

The system evolves by:
\begin{enumerate}
  \item \textit{Recognize}: Find applicable rules
  \item \textit{Resolve}: Resolve conflicts, i.e. choose the rule that should fire
  \item \textit{Act}: Fire the rule by executing its actions
  \item Start over until no rules are applicable anymore
\end{enumerate}

Elements of the working memory are given as \texttt{(type $attr_1$ $value_1$ \dots\, $attr_n$ $value_n$)}.
Similarly the rule conditions are given as
\texttt{(type $attr_1$ $spec_1$ \dots) }, where the specifications $spec_i$ are either expressions in brackets
$age$ $[n+4]$ or tests enclosed in braces, e.g. $age$ ${< 23}$.

The possible actions are as follows:

\begin{itemize}
  \item \texttt{ADD $pattern$}
  \item \texttt{REMOVE $index$} where $index$ is the number of the matched condition starting at $1$.
  \item \texttt{MODIFY $index$ ($expr$)} with $index$ again being the number of the matched cond. starting at $1$
\end{itemize}
A complete rule then might look like
\texttt{IF (Person age x) (Birthday) THEN (MODIFY 1 (age x + 1); REMOVE 2) }

There are several viable strategies to \textbf{resolve conflicts}:
\begin{itemize}
  \item \textit{Arbitrary Choice}
  \item \textit{First matching rule}
  \item \textit{Specificity}, choose most specific rule
  \item \textit{Recency}, e.g. choose rule using the most recently modified working memory element,
    or choose least recently used rule
  \item \textit{Refractoriness}, try to never use the same rule for the same variables again
\end{itemize}

